<?php
/**
 * Class for  Generator Image Color Palette.  
 * This file is class for return  mamimum used colors in image, format return in HTML or RGB format. 
 *
 * PHP versions 4 and 5
 * Licensed under The GPL License
 *
 * Developed By 	Kalpeh Gamit
 * E-mail 			Kalpa.programmer@gmail.com
 *
 * @filesource
 * @copyright     Copyright 2009, InScripter Inc. (http://www.inscripter.com)
 * @link          http://www.inscripter.com
 * @package       PHP
 * @version       GetImageColor-1.0.0
 * @license       http://www.opensource.org/licenses/gpl-2.0.php The GPL License
 */
 
/**
 * :
 *	$img = new GeneratorImageColorPalette();
 *	$colors = $img->getImageColor($pic , $colors_num, $step);
 *	
 * 	$pic = '  '; (string)
 *	$colors_num = '  '; (int)
 *	$step = '     '; (int)
 *
 *	$colors ->    ( [  hex]=>[ ] )
 */

// start of class : Generator Image Color Palette 
class image_colors 
{
	static public $error = 1; 
	//default 0x33;
	//  
	
	// get image color in RGB format function 
	function getImageColor($imageFile_URL, $numColors, $image_granularity = 5){
   		$image_granularity = max(1, abs((int)$image_granularity));
   		$colors = array();
   		//find image size
   		list($w_i, $h_i, $type) = @getimagesize($imageFile_URL);
   		
		if(!$w_i){
      		user_error("Unable to get image size data");
      		return false;
   		}
   		$types = array('','gif','jpeg','png');
        $ext = $types[$type];
		if ($type == 2) {
			$img = imagecreatefromjpeg($imageFile_URL);
		} else {
			$func = 'imagecreatefrom'.$ext;
			$img = $func($imageFile_URL);
		}
   		if(!$img){

			user_error("Unable to open image file");
   		   return false;
   		}
   		
   		// fetch color in RGB format
   		for($x = 0; $x < $w_i; $x += $image_granularity){
      		for($y = 0; $y < $h_i; $y += $image_granularity){
         		$thisColor = imagecolorat($img, $x, $y);
         		$rgb = imagecolorsforindex($img, $thisColor);

        		$red = round(round(($rgb['red'] / self::$error)) * self::$error);
         		$green = round(round(($rgb['green'] / self::$error)) * self::$error);
         		$blue = round(round(($rgb['blue'] / self::$error)) * self::$error);
				
						$red = ($red>255) ? 255 : $red;
						$green = ($green>255) ? 255 : $green;
						$blue = ($blue>255) ? 255 : $blue;
						
						$red = dechex($red);
						$green = dechex($green);
						$blue = dechex($blue);
						
						$red = (strlen($red) == 1) ? '0'.$red : $red;
						$green = (strlen($green) == 1) ? '0'.$green : $green;
						$blue = (strlen($blue) == 1) ? '0'.$blue : $blue;
						

						$thisRGB = $red.$green.$blue;
				
         		if(array_key_exists($thisRGB, $colors)){
           			 $colors[$thisRGB]++;
         		}else{
           			 $colors[$thisRGB] = 1;
         		}
      		}
   		}
			$allowDiff = 10.0;
			
			arsort($colors);
			$color_keys = array_slice(array_keys($colors), 0, 100,true);
			$color_counts =array_slice(array_values($colors), 0, 100,true);
			//$color_keys = array_keys($colors);
			//$color_counts =array_values($colors);
			for($i=0;$i<count($color_keys);$i++){
				if( $color_keys[$i] )
					for($j=$i+1;$j<count($color_keys);$j++){
						if( self::getDistanceBetweenColors(self::hex_to_rgb($color_keys[$i]),self::hex_to_rgb($color_keys[$j]))<=$allowDiff ){
							$color_keys[$i] = self::color_avg($color_keys[$i],$color_keys[$j],0.5);
							$color_counts[$i] = $color_counts[$i]+$color_counts[$j];
							$color_keys[$j] = '';
							$color_counts[$j] = 0;
						}
					}
			}
			
			for($i=0;$i<count($color_keys);$i++){
				if( !$color_keys[$i] ){
					unset( $color_keys[$i] );
					unset( $color_counts[$i] );
				}
			}
				
			$colors =array_combine($color_keys,$color_counts);
   		arsort($colors);
		//	print_r($colors);
   		return array_slice(array_keys($colors), 0, $numColors,true);
	}
	public static function color_avg($color1,$color2,$factor) {
		// extract RGB values for color1.
		list($r1,$g1,$b1) = str_split(ltrim($color1,'#'),2);
		// extract RGB values for color2.
		list($r2,$g2,$b2) = str_split(ltrim($color2,'#'),2);

		// get the average RGB values.
		$r_avg = (hexdec($r1)*(1-$factor)+hexdec($r2)*$factor);
		$g_avg = (hexdec($g1)*(1-$factor)+hexdec($g2)*$factor);
		$b_avg = (hexdec($b1)*(1-$factor)+hexdec($b2)*$factor);

		// construct the result color.    
		$color_avg = sprintf("%02s",dechex($r_avg)).
								sprintf("%02s",dechex($g_avg)).
								sprintf("%02s",dechex($b_avg));


		// return it.
		return $color_avg;
	}
	public static function hex_to_rgb($hex){
		$hex = str_replace('#', '', $hex);
		if(strlen($hex) == 3) {
			$r = hexdec(substr($hex,0,1).substr($hex,0,1));
			$g = hexdec(substr($hex,1,1).substr($hex,1,1));
			$b = hexdec(substr($hex,2,1).substr($hex,2,1));
		} else {
			$r = hexdec(substr($hex,0,2));
			$g = hexdec(substr($hex,2,2));
			$b = hexdec(substr($hex,4,2));
		}
		return array($r, $g, $b);
	}
	public static function getDistanceBetweenColors( $col1, $col2 ) {

		$xyz1 = self::rgb_to_xyz( $col1 );
		$xyz2 = self::rgb_to_xyz( $col2 );

		$lab1 = self::xyz_to_lab( $xyz1 );
		$lab2 = self::xyz_to_lab( $xyz2 );

		return ciede2000( $lab1, $lab2 );
	}
	
	public static function xyz_to_lab( $xyz ){
		 $x = $xyz[0];
		 $y = $xyz[1];
		 $z = $xyz[2];
		 $_x = $x/95.047;
		 $_y = $y/100;
		 $_z = $z/108.883;
		 if($_x>0.008856){
			  $_x = pow($_x,1/3);
		 }
		 else{
			  $_x = 7.787*$_x + 16/116;
		 }
		 if($_y>0.008856){
			  $_y = pow($_y,1/3);
		 }
		 else{
			  $_y = (7.787*$_y) + (16/116);
		 }
		 if($_z>0.008856){
			  $_z = pow($_z,1/3);
		 }
		 else{
			  $_z = 7.787*$_z + 16/116;
		 }
		 $l= 116*$_y -16;
		 $a= 500*($_x-$_y);
		 $b= 200*($_y-$_z);
		 
		 return(array( 'l' => $l, 'a' => $a, 'b' => $b));
	}


	public function rgb_to_xyz( $rgb ) {
		$red = $rgb[0];
		$green = $rgb[1];
		$blue = $rgb[2]; 
		$_red = $red/255;
		$_green = $green/255;
		$_blue = $blue/255;

		if ( $_red > 0.04045 ) {
			$_red = ($_red+0.055)/1.055;
			$_red = pow($_red,2.4);
		} else{
			$_red = $_red/12.92;
		}

		if ( $_green > 0.04045 ) {
		  $_green = ($_green+0.055)/1.055;
		  $_green = pow($_green,2.4);     
		} else{
		  $_green = $_green/12.92;
		}

		if ( $_blue>0.04045 ) {
		  $_blue = ($_blue+0.055)/1.055;
		  $_blue = pow($_blue,2.4);     
		} else {
		  $_blue = $_blue/12.92;
		}

		$_red *= 100;
		$_green *= 100;
		$_blue *= 100;
		$x = $_red * 0.4124 + $_green * 0.3576 + $_blue * 0.1805;
		$y = $_red * 0.2126 + $_green * 0.7152 + $_blue * 0.0722;
		$z = $_red * 0.0193 + $_green * 0.1192 + $_blue * 0.9505;
		return(array( $x, $y, $z ));
	}
	
	// html color to convert in RGB format color like R(255) G(255) B(255)  
	function getHtml2Rgb($str_color)
	{
    	if ($str_color[0] == '#')
        	$str_color = substr($str_color, 1);

  	  	if (strlen($str_color) == 6)
        	list($r, $g, $b) = array($str_color[0].$str_color[1],
                                 $str_color[2].$str_color[3],
                                 $str_color[4].$str_color[5]);
    	elseif (strlen($str_color) == 3)
        	list($r, $g, $b) = array($str_color[0].$str_color[0], $str_color[1].$str_color[1], $str_color[2].$str_color[2]);
    	else
        	return false;

    	$r = hexdec($r); $g = hexdec($g); $b = hexdec($b);
    	$arr_rgb = array($r, $g, $b);
		// Return colors format liek R(255) G(255) B(255)  
    	return $arr_rgb;
	}
	
// end of class here : Generator Image Color Palette  
}

