<?php
// ,   ""  
function getDistance($arr1, $arr2, $l) {
	//  "  "   ,         
	$s = 0;
	for($i = 0; $i < $l; ++$i)
		$s += $arr1[$i] > $arr2[$i] ? ($arr1[$i] - $arr2[$i]) : ($arr2[$i] - $arr1[$i]);
	return $s;
}

/*
 ,    
,  :
	$url      
	$amount   ,   
	$sort         
	$maxPreSize      (  )
	$epselon    ,     
*/
function getDominantColors($url, $amount = 1, $sort = true, $maxPreSize = 50, $epselon = 1) {
	// ,    .  ,   .
	if(!file_exists($url))
		return false;
	//   ,   .
	$size = getimagesize($url);
	if($size === false)
		return false;
	$width = $size[0];
	$height = $size[1];
	//        ,   ,     .  ,     ,   .
	$format = strtolower(substr($size['mime'], strpos($size['mime'], '/') + 1));
	if($format == 'x-ms-bmp')
		$format = 'wbmp';
	$func = 'imagecreatefrom'.$format;
	if(!function_exists($func))
		return false;
	$bitmap = @$func($url);
	if(!$bitmap)
		return false;

	//     ,       ,    .     .       .
	$newW = $width > $maxPreSize ? $maxPreSize : $width;
	$newH = $height > $maxPreSize ? $maxPreSize : $height;
	$bitmapNew = imagecreatetruecolor($newW, $newH);
	//       imageCopyResambled,      ,       imageCopyResized.
	imageCopyResized($bitmapNew, $bitmap, 0, 0, 0, 0, $newW, $newH, $width, $height);
	//        
	$pixelsAmount = $newW * $newH;
	$pixels = Array();
	for($i = 0; $i < $newW; ++$i)
		for($j = 0; $j < $newH; ++$j) {
			$rgb = imagecolorat($bitmapNew, $i, $j);
			$pixels[] = Array(
				($rgb >> 16) & 0xFF,
				($rgb >> 8) & 0xFF,
				$rgb & 0xFF
			);
		}
	imagedestroy($bitmapNew);
	
	//        
	$clusters = Array();
	$pixelsChosen = Array();
	for($i = 0; $i < $amount; ++$i) {
		//        
		do {
			$id = rand(0, $pixelsAmount - 1);
		} while(in_array($id, $pixelsChosen));
		$pixelsChosen[] = $id;
		$clusters[] = $pixels[$id];
	}
	
	$clustersPixels = Array();
	$clustersAmounts = Array();
	//  
	do {
		//   ,      
		for($i = 0; $i < $amount; ++$i) {
			$clustersPixels[$i] = Array();
			$clustersAmounts[$i] = 0;
		}
		
		//          	
		for($i = 0; $i < $pixelsAmount; ++$i) {
			$distMin = -1;
			$id = 0;
			for($j = 0; $j < $amount; ++$j) {
				$dist = getDistance($pixels[$i], $clusters[$j], 3);
				if($distMin == -1 or $dist < $distMin) {
					$distMin = $dist;
					$id = $j;
				}
			}
			$clustersPixels[$id][] = $i;
			++$clustersAmounts[$id];
		}
		
		//      ,  ,  ,   
		$diff = 0;
		for($i = 0; $i < $amount; ++$i) {
			if($clustersAmounts[$i] > 0) {
				$old = $clusters[$i];
				for($k = 0; $k < 3; ++$k) {
					$clusters[$i][$k] = 0;
					for($j = 0; $j < $clustersAmounts[$i]; ++$j)
						$clusters[$i][$k] += $pixels[$clustersPixels[$i][$j]][$k];
					$clusters[$i][$k] /= $clustersAmounts[$i];
				}
				//    
				$dist = getDistance($old, $clusters[$i], 3);
				$diff = $diff > $dist ? $diff : $dist;
			}
		}
	} while($diff >= $epselon);
	
	//    (    )
	if($sort and $amount > 1)
		for($i = 1; $i < $amount; ++$i)
			for($j = $i; $j >= 1 and $clustersAmounts[$j] > $clustersAmounts[$j - 1]; --$j) {
				$t = $clustersAmounts[$j - 1];
				$clustersAmounts[$j - 1] = $clustersAmounts[$j];
				$clustersAmounts[$j] = $t;
				
				$t = $clusters[$j - 1];
				$clusters[$j - 1] = $clusters[$j];
				$clusters[$j] = $t;
			}
	
	//     ,    
	for($i = 0; $i < $amount; ++$i)
		for($j = 0; $j < 3; ++$j)
			$clusters[$i][$j] = floor($clusters[$i][$j]);
	
	//  
	imagedestroy($bitmap);
	
	//  ,    .    ,   3-   ,     .
	
	return array_map(RGB_to_HEX,$clusters);
}
function RGB_to_HEX($rgb){
	$red = dechex($rgb[0]);
	$green = dechex($rgb[1]);
	$blue = dechex($rgb[2]);
	
	$red = (strlen($red) == 1) ? '0'.$red : $red;
	$green = (strlen($green) == 1) ? '0'.$green : $green;
	$blue = (strlen($blue) == 1) ? '0'.$blue : $blue;
	

	return $red.$green.$blue;
}